unit uPluginFacturasCliente;

interface

uses
  uModuleController, uInterfaces, uHostManager, Menus, Classes, ActnList,
  ImgList, Controls, PngImageList, uPlugins_Intf;

type
  TPluginFacturasCliente = class(TModuleController, IMCFacturasCliente)
    actFacturasCliente: TAction;
    ExtraImages: TPngImageList;
    LargeImages: TPngImageList;
    MainMenu: TMainMenu;
    ModuleActionList: TActionList;
    SmallImages: TPngImageList;
    Ventas1: TMenuItem;
    Facturasdecliente1: TMenuItem;
    procedure actFacturasClienteExecute(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure VerFacturas(const ID_Cliente: Integer;
      const ANombreCliente : String = '');    
  end;

implementation

{$R *.dfm}

uses
  Forms, Dialogs, SysUtils, cxControls,
  uFacturasClienteController, uBizFacturasCliente, uFacturasClienteViewRegister;

function GetModule : TModuleController;
begin
  Result := TPluginFacturasCliente.Create(NIL);
end;

exports
  GetModule name GET_MODULE_FUNC;

procedure TPluginFacturasCliente.actFacturasClienteExecute(Sender: TObject);
var
  AFacturasClienteController : IFacturasClienteController;
  AFacturasCliente : IBizFacturaCliente;

begin
  AFacturasClienteController := TFacturasClienteController.Create;
  AFacturasCliente := (AFacturasClienteController.BuscarTodos as IBizFacturaCliente);
  AFacturasClienteController.VerTodos(AFacturasCliente);
end;

constructor TPluginFacturasCliente.Create(AOwner: TComponent);
begin
  inherited;
  ModuleName := MODULENAME_FACTURAS_CLIENTE;
  uFacturasClienteViewRegister.RegisterViews;
end;

destructor TPluginFacturasCliente.Destroy;
begin
  uFacturasClienteViewRegister.UnregisterViews;
  inherited;
end;

procedure TPluginFacturasCliente.VerFacturas(const ID_Cliente: Integer;
  const ANombreCliente: String);
var
  AFacturasClienteController : IFacturasClienteController;
  AFacturasCliente : IBizFacturaCliente;
  AText : String;
begin
  AText := Format('Lista de facturas del cliente %s', [ANombreCliente]);
  AFacturasClienteController := TFacturasClienteController.Create;
  try
    ShowHourglassCursor;
    try
      AFacturasCliente := AFacturasClienteController.BuscarTodos(ID_Cliente);      
    finally
      HideHourglassCursor;
    end;
    AFacturasClienteController.VerTodos(AFacturasCliente, True, AText);
  finally
    AFacturasCliente := NIL;
    AFacturasClienteController := NIL;
  end;
end;


initialization
  RegisterModuleClass(TPluginFacturasCliente);

finalization
  UnRegisterModuleClass(TPluginFacturasCliente);

end.
